"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Injectable = void 0;
const util_1 = require("./util");
const dependencies = Symbol("dependencies");
function defineAccessor(target, prop) {
    Object.defineProperty(target, prop, {
        configurable: false,
        enumerable: false,
        get() {
            let { module, route } = this[dependencies][prop];
            return module(route);
        }
    });
}
function addDependency(dependency) {
    return (target, prop) => {
        if (target[dependencies] === undefined) {
            target[dependencies] = util_1.dict();
        }
        target[dependencies][prop] = dependency;
        defineAccessor(target, prop);
    };
}
class Injectable {
    inject(route = void 0) {
        return addDependency({
            module: this,
            route
        });
    }
}
exports.Injectable = Injectable;
//# sourceMappingURL=di.js.map